﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Windows.Forms;
using System.Drawing.Drawing2D;

namespace CHRMapper
{
    public class TileMap
    {
        byte[,] Map;
        byte Brush;
        Bitmap[] TileSet;
        Graphics MD;
        public Graphics MapDraw { get { return MD; } set { MD = value; MD.CompositingMode = CompositingMode.SourceCopy; MD.CompositingQuality = CompositingQuality.HighSpeed; } }
        public TileMap(byte[,] TileID, Bitmap[] TileSet)
        {
            Map=TileID;
            this.TileSet = TileSet;
        }

        public Bitmap Render()
        {
            return RenderMap(Map, TileSet);
        }
        Bitmap RenderMap(byte[,] Map, Bitmap[] Tile)
        {
            Bitmap Output = new Bitmap(Map.GetLength(0) << 4, Map.GetLength(1) << 4);
            MD = Graphics.FromImage((Image)new Bitmap(Map.GetLength(0) << 4, Map.GetLength(1) << 4));
            for (int xi = 0, xl = Map.GetLength(0); xi < xl; xi++)
                for (int yi = 0, yl = Map.GetLength(1); yi < yl; yi++)
                    MD.DrawImage(Tile[Map[xi, yi]], new Rectangle(xi << 4, yi << 4, 16, 16));
            return Output;
        }
    }
}
